PF-build.sh 62 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957958959960961962963964965966967968969970971972973974975976977978979980981982983984985986987988989990991992993994995996997998999100010011002100310041005100610071008100910101011101210131014101510161017101810191020102110221023102410251026102710281029103010311032103310341035103610371038103910401041104210431044104510461047104810491050105110521053105410551056105710581059106010611062106310641065106610671068106910701071107210731074107510761077107810791080108110821083108410851086108710881089109010911092109310941095109610971098109911001101110211031104110511061107110811091110111111121113111411151116111711181119112011211122112311241125112611271128112911301131113211331134113511361137113811391140114111421143114411451146114711481149115011511152115311541155115611571158115911601161116211631164116511661167116811691170117111721173117411751176117711781179118011811182118311841185118611871188118911901191119211931194119511961197119811991200120112021203120412051206120712081209121012111212121312141215121612171218121912201221122212231224122512261227122812291230123112321233123412351236123712381239
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 2.0.0-Build_55
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. # 12 Feb 2021, 3d-gussner, Add MK404-build.sh
  140. # 13 Feb 2021, 3d-gussner, Indentations
  141. # 13 Feb 2021, 3d-gussner, MK404 improvements like "flash" MK3, MK3S languages files to MK404 xflash.
  142. # 27 Feb 2021, 3d-gussner, Add './lang-community.sh' and update exits
  143. # 03 May 2021, 3d-gussner, Update exit numbers
  144. # 01-14 prepare build env
  145. # 21-32 prepare compiling
  146. # 41-47 compiling
  147. # 51-54 cleanup
  148. # 61-62 MK404
  149. # 03 May 2021, 3d-gussner, Update documentation and change version to v1.2.0
  150. # 03 May 2021, 3d-gussner, Add SIM atmega404
  151. # 17 Jun 2021, 3d-gussner, Update PF-build.sh to work after DRracer Remove FW version parsing PR
  152. # 17 Jun 2021, 3d-gussner, Save ELF files for FW3.10.1 debugging PRs
  153. # 17 Jun 2021, 3d-gussner, Add verbose_IDE to output more information during build
  154. # 17 Jun 2021, 3d-gussner, Change version to v2.0.0
  155. #### Start check if OSTYPE is supported
  156. OS_FOUND=$( command -v uname)
  157. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  158. linux*)
  159. TARGET_OS="linux"
  160. ;;
  161. msys*|cygwin*|mingw*)
  162. # or possible 'bash on windows'
  163. TARGET_OS='windows'
  164. ;;
  165. nt|win*)
  166. TARGET_OS='windows'
  167. ;;
  168. *)
  169. TARGET_OS='unknown'
  170. ;;
  171. esac
  172. # Windows
  173. if [ $TARGET_OS == "windows" ]; then
  174. if [ $(uname -m) == "x86_64" ]; then
  175. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  176. Processor="64"
  177. elif [ $(uname -m) == "i386" ]; then
  178. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  179. Processor="32"
  180. else
  181. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  182. echo "Please refer to the notes of build.sh$(tput sgr0)"
  183. exit 1
  184. fi
  185. # Linux
  186. elif [ $TARGET_OS == "linux" ]; then
  187. if [ $(uname -m) == "x86_64" ]; then
  188. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  189. Processor="64"
  190. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  191. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  192. Processor="32"
  193. else
  194. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  195. echo "Please refer to the notes of build.sh$(tput sgr0)"
  196. exit 1
  197. fi
  198. else
  199. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  200. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  201. echo "Read the notes of build.sh$(tput sgr0)"
  202. exit 1
  203. fi
  204. sleep 2
  205. #### End check if OSTYPE is supported
  206. #### Prepare bash environment and check if wget, zip and other needed things are available
  207. # Check wget
  208. if ! type wget > /dev/null; then
  209. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  210. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  211. exit 2
  212. fi
  213. # Check for zip
  214. if ! type zip > /dev/null; then
  215. if [ $TARGET_OS == "windows" ]; then
  216. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  217. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  218. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  219. echo "Run git Bash under Administrator privilege and"
  220. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  221. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  222. exit 3
  223. elif [ $TARGET_OS == "linux" ]; then
  224. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  225. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  226. #sudo apt-get update && apt-get install zip
  227. exit 3
  228. fi
  229. fi
  230. # Check python ... needed during language build
  231. if ! type python > /dev/null; then
  232. if [ $TARGET_OS == "windows" ]; then
  233. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  234. exit 4
  235. elif [ $TARGET_OS == "linux" ]; then
  236. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  237. echo "As Python 2.x will not be maintained from 2020 please,"
  238. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  239. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  240. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  241. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  242. exit 4
  243. fi
  244. fi
  245. # Check gawk ... needed during language build
  246. if ! type gawk > /dev/null; then
  247. if [ $TARGET_OS == "linux" ]; then
  248. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  249. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  250. #sudo apt-get update && apt-get install gawk
  251. exit 5
  252. fi
  253. fi
  254. #### End prepare bash / Linux environment
  255. # Check for options/flags
  256. while getopts b:c:d:f:g:h:i:j:l:m:n:o:p:v:x:?h flag
  257. do
  258. case "${flag}" in
  259. b) build_flag=${OPTARG};;
  260. c) clean_flag=${OPTARG};;
  261. d) devel_flag=${OPTARG};;
  262. f) board_flash_flag=${OPTARG};;
  263. g) graphics_flag=${OPTARG};;
  264. h) help_flag=1;;
  265. i) IDE_flag=${OPTARG};;
  266. j) verbose_IDE_flag=${OPTARG};;
  267. l) language_flag=${OPTARG};;
  268. m) mk404_flag=${OPTARG};;
  269. n) new_build_flag=${OPTARG};;
  270. o) output_flag=${OPTARG};;
  271. p) prusa_flag=${OPTARG};;
  272. v) variant_flag=${OPTARG};;
  273. x) board_mem_flag=${OPTARG};;
  274. ?) help_flag=1;;
  275. esac
  276. done
  277. #
  278. # '?' 'h' argument usage and help
  279. if [ "$help_flag" == "1" ] ; then
  280. echo "***************************************"
  281. echo "* PF-build.sh Version: 2.0.0-Build_55 *"
  282. echo "***************************************"
  283. echo "Arguments:"
  284. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  285. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  286. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  287. echo "$(tput setaf 2)-f$(tput sgr0) Board flash size '$(tput setaf 2)256$(tput sgr0)','$(tput setaf 2)384$(tput sgr0)','$(tput setaf 2)512$(tput sgr0)','$(tput setaf 2)1024$(tput sgr0)''$(tput setaf 2)32M$(tput sgr0)'"
  288. echo "$(tput setaf 2)-g$(tput sgr0) Start MK404 grafics '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' lite '$(tput setaf 2)2$(tput sgr0)' fancy"
  289. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  290. echo "$(tput setaf 2)-i$(tput sgr0) Arduino IDE version '$(tput setaf 2)1.8.5$(tput sgr0)', '$(tput setaf 2)1.8.13$(tput sgr0)'"
  291. echo "$(tput setaf 2)-j$(tput sgr0) Arduino IDE verbose output '$(tput setaf 2)0$(tput sgr0)', '$(tput setaf 2)1$(tput sgr0) active'"
  292. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  293. echo "$(tput setaf 2)-m$(tput sgr0) Start MK404 sim '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes '$(tput setaf 2)2$(tput sgr0)' with MMU2"
  294. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  295. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  296. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  297. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  298. echo "$(tput setaf 2)-x$(tput sgr0) Board memory size '$(tput setaf 2)8$(tput sgr0)' or '$(tput setaf 2)64$(tput sgr0)' Kb."
  299. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  300. echo
  301. echo "Brief USAGE:"
  302. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-v] [-l] [-d] [-b] [-o] [-c] [-p] [-n]"
  303. echo
  304. echo "Example:"
  305. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  306. echo " Will build all variants as multi language and final GOLD version"
  307. echo
  308. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  309. echo " Will build MK3S multi language final GOLD firmware "
  310. echo " with current commit count number and output extra information,"
  311. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  312. echo
  313. exit 6
  314. fi
  315. #Check if verbose_IDE is selected with argument '-j'
  316. if [ ! -z "$verbose_IDE_flag" ]; then
  317. if [ $verbose_IDE_flag == "1" ]; then
  318. verbose_IDE="1"
  319. elif [ $verbose_IDE_flag == "0" ]; then
  320. verbose_IDE="0"
  321. else
  322. echo "Only '0' and '1' are valid verbose_IDE values."
  323. exit
  324. fi
  325. else
  326. verbose_IDE="0"
  327. fi
  328. #Check if Build is selected with argument '-f'
  329. if [ ! -z "$board_flash_flag" ] ; then
  330. if [ "$board_flash_flag" == "256" ] ; then
  331. BOARD_FLASH="0x3FFFF"
  332. BOARD_maximum_size="253952"
  333. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  334. elif [ "$board_flash_flag" == "384" ] ; then
  335. BOARD_FLASH="0x5FFFF"
  336. BOARD_maximum_size="385024"
  337. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  338. elif [ "$board_flash_flag" == "512" ] ; then
  339. BOARD_FLASH="0x7FFFF"
  340. BOARD_maximum_size="516096"
  341. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  342. elif [ "$board_flash_flag" == "1024" ] ; then
  343. BOARD_FLASH="0xFFFFF"
  344. BOARD_maximum_size="1040384"
  345. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  346. elif [[ "$board_flash_flag" == "32M" || "$board_flash_flag" == "32768" ]] ; then
  347. BOARD_FLASH="0x1FFFFFF"
  348. BOARD_maximum_size="33546240"
  349. echo "Board flash size : 32 Mb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  350. else
  351. echo "Unsupported board flash size chosen. Only '256', '384', '512', '1024' and '32M' are allowed."
  352. exit 7
  353. fi
  354. fi
  355. #Check if Build is selected with argument '-x'
  356. if [ ! -z "$board_mem_flag" ] ; then
  357. if [ "$board_mem_flag" == "8" ] ; then
  358. BOARD_MEM="0x21FF"
  359. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  360. elif [ "$board_mem_flag" == "64" ] ; then
  361. BOARD_MEM="0xFFFF"
  362. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  363. else
  364. echo "Unsupported board mem size chosen. Only '8', '64' are allowed."
  365. exit 8
  366. fi
  367. fi
  368. #Check if Arduino IDE version is correct
  369. if [ ! -z "$IDE_flag" ]; then
  370. if [[ "$IDE_flag" == "1.8.5" || "$IDE_flag" == "1.8.13" ]]; then
  371. ARDUINO_ENV="${IDE_flag}"
  372. else
  373. ARDUINO_ENV="1.8.5"
  374. fi
  375. else
  376. ARDUINO_ENV="1.8.5"
  377. fi
  378. #### Set build environment
  379. BUILD_ENV="1.0.6"
  380. BOARD="prusa_einsy_rambo"
  381. BOARD_PACKAGE_NAME="PrusaResearch"
  382. BOARD_VERSION="1.0.3"
  383. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  384. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  385. BOARD_FILENAME="prusa3dboards"
  386. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  387. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  388. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  389. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  390. LIB="PrusaLibrary"
  391. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  392. # List few useful data
  393. echo
  394. echo "Script path :" $SCRIPT_PATH
  395. echo "OS :" $OS
  396. echo "OS type :" $TARGET_OS
  397. echo ""
  398. echo "Arduino IDE :" $ARDUINO_ENV
  399. echo "Build env :" $BUILD_ENV
  400. echo "Board :" $BOARD
  401. if [ ! -z "$BOARD_FLASH" ] ; then
  402. echo "Board flash :" $BOARD_FLASH
  403. fi
  404. if [ ! -z "$BOARD_MEM" ] ; then
  405. echo "Board mem :" $BOARD_MEM
  406. fi
  407. echo "Package name:" $BOARD_PACKAGE_NAME
  408. echo "Board v. :" $BOARD_VERSION
  409. echo "Specific Lib:" $LIB
  410. echo ""
  411. #### Start prepare building environment
  412. #Check if build exists and creates it if not
  413. if [ ! -d "../PF-build-dl" ]; then
  414. mkdir ../PF-build-dl || exit 9
  415. fi
  416. cd ../PF-build-dl || exit 10
  417. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  418. # Check if PF-build-env-<version> exists and downloads + creates it if not
  419. # The build environment is based on the supported Arduino IDE portable version with some changes
  420. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  421. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  422. mkdir ../PF-build-env-$BUILD_ENV
  423. sleep 5
  424. fi
  425. # Download and extract supported Arduino IDE depending on OS
  426. # Windows
  427. if [ $TARGET_OS == "windows" ]; then
  428. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  429. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  430. sleep 2
  431. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 8
  432. echo "$(tput sgr 0)"
  433. fi
  434. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  435. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  436. sleep 2
  437. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 9
  438. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  439. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  440. echo "$(tput sgr0)"
  441. fi
  442. fi
  443. # Linux
  444. if [ $TARGET_OS == "linux" ]; then
  445. # 32 or 64 bit version
  446. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  447. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  448. sleep 2
  449. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  450. echo "$(tput sgr 0)"
  451. fi
  452. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  453. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  454. sleep 2
  455. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 9
  456. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  457. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  458. echo "$(tput sgr0)"
  459. fi
  460. fi
  461. # Make Arduino IDE portable
  462. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  463. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  464. fi
  465. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  466. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  467. fi
  468. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  469. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  470. fi
  471. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  472. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  473. fi
  474. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  475. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  476. fi
  477. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  478. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  479. fi
  480. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  481. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  482. fi
  483. # Change Arduino IDE preferences
  484. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  485. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  486. sleep 2
  487. echo "update.check"
  488. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  489. echo "board"
  490. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  491. echo "editor.linenumbers"
  492. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  493. echo "boardsmanager.additional.urls"
  494. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  495. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  496. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  497. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  498. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  499. echo "$(tput sgr0)"
  500. fi
  501. # Download and extract Prusa Firmware related parts
  502. # Download and extract PrusaResearchRambo board
  503. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  504. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  505. sleep 2
  506. wget $BOARD_FILE_URL || exit 10
  507. fi
  508. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  509. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  510. sleep 2
  511. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 11
  512. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  513. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  514. fi
  515. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  516. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  517. fi
  518. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  519. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  520. fi
  521. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  522. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  523. fi
  524. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  525. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  526. echo "$(tput sgr 0)"
  527. fi
  528. # Download and extract Prusa Firmware specific library files
  529. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  530. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  531. sleep 2
  532. wget $PF_BUILD_FILE_URL || exit 12
  533. echo "$(tput sgr 0)"
  534. fi
  535. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  536. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  537. sleep 2
  538. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 13
  539. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  540. echo "$(tput sgr0)"
  541. fi
  542. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  543. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  544. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  545. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  546. sleep 2
  547. fi
  548. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  549. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  550. sleep 2
  551. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  552. sleep 2
  553. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  554. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  555. echo "$(tput sgr0)"
  556. fi
  557. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  558. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  559. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  560. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  561. sleep 2
  562. echo "$(tput sgr0)"
  563. exit 14
  564. fi
  565. #### End prepare building
  566. #### Start
  567. cd $SCRIPT_PATH
  568. # Check if git is available
  569. if type git > /dev/null; then
  570. git_available="1"
  571. fi
  572. #
  573. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  574. if [ -z "$variant_flag" ] ; then
  575. # Select which variant of the Prusa Firmware will be compiled, like
  576. PS3="Select a variant: "
  577. while IFS= read -r -d $'\0' f; do
  578. options[i++]="$f"
  579. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  580. select opt in "${options[@]}" "All" "Quit"; do
  581. case $opt in
  582. *.h)
  583. VARIANT=$(basename "$opt" ".h")
  584. VARIANTS[i++]="$opt"
  585. break
  586. ;;
  587. "All")
  588. VARIANT="All"
  589. VARIANTS=${options[*]}
  590. break
  591. ;;
  592. "Quit")
  593. echo "You chose to stop"
  594. exit 22
  595. ;;
  596. *)
  597. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  598. ;;
  599. esac
  600. done
  601. else
  602. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  603. VARIANTS=$variant_flag
  604. elif [ "$variant_flag" == "All" ] ; then
  605. while IFS= read -r -d $'\0' f; do
  606. options[i++]="$f"
  607. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  608. VARIANT="All"
  609. VARIANTS=${options[*]}
  610. else
  611. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  612. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  613. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  614. echo "$(tput sgr0)"
  615. exit 23
  616. fi
  617. fi
  618. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  619. #Check default language mode
  620. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  621. if [ -z "$language_flag" ] ; then
  622. PS3="Select a language: "
  623. echo
  624. echo "Which lang-build do you want?"
  625. select yn in "Multi languages" "English only"; do
  626. case $yn in
  627. "Multi languages")
  628. LANGUAGES="ALL"
  629. break
  630. ;;
  631. "English only")
  632. LANGUAGES="EN_ONLY"
  633. break
  634. ;;
  635. *)
  636. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  637. ;;
  638. esac
  639. done
  640. else
  641. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  642. LANGUAGES=$language_flag
  643. else
  644. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  645. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  646. exit 24
  647. fi
  648. fi
  649. #Check if DEV_STATUS is selected via argument '-d'
  650. if [ ! -z "$devel_flag" ] ; then
  651. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  652. DEV_STATUS_SELECTED=$devel_flag
  653. elif [[ "$devel_flag" == "atmega404" || "$devel_flag" == "atmega404_no_bootloader" ]] ; then
  654. MK404_DEBUG=$devel_flag
  655. else
  656. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  657. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  658. exit 25
  659. fi
  660. fi
  661. #Check if Build is selected via argument '-b'
  662. if [ ! -z "$build_flag" ] ; then
  663. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  664. echo "Build changed to $build_flag"
  665. BUILD=$(git rev-list --count HEAD)
  666. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  667. BUILD=$build_flag
  668. else
  669. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  670. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  671. exit 26
  672. fi
  673. echo "New Build number is: $BUILD"
  674. fi
  675. # check if script has been started with arguments
  676. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  677. OUTPUT=1
  678. else
  679. OUTPUT=0
  680. fi
  681. #echo "Output is:" $OUTPUT
  682. #Check git branch has changed
  683. if [ ! -z "git_available" ]; then
  684. BRANCH=""
  685. CLEAN_PF_FW_BUILD=0
  686. else
  687. BRANCH=$(git branch --show-current)
  688. echo "Current branch is:" $BRANCH
  689. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  690. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  691. echo "created PF-build.branch file"
  692. else
  693. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  694. echo "Previous branch was:" $PRE_BRANCH
  695. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  696. CLEAN_PF_FW_BUILD=1
  697. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  698. fi
  699. fi
  700. fi
  701. #Set BUILD_ENV_PATH
  702. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 27
  703. BUILD_ENV_PATH="$( pwd -P )"
  704. cd ../..
  705. #Checkif BUILD_PATH exists and if not creates it
  706. if [ ! -d "Prusa-Firmware-build" ]; then
  707. mkdir Prusa-Firmware-build || exit 28
  708. fi
  709. #Set the BUILD_PATH for Arduino IDE
  710. cd Prusa-Firmware-build || exit 29
  711. BUILD_PATH="$( pwd -P )"
  712. #Check git branch has changed
  713. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  714. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  715. rm -r *
  716. else
  717. echo "Nothing to clean up"
  718. fi
  719. for v in ${VARIANTS[*]}
  720. do
  721. VARIANT=$(basename "$v" ".h")
  722. MK404_PRINTER=$(grep --max-count=1 "\bPRINTER_TYPE\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3 | cut -d '_' -f2)
  723. # Find firmware version in Configuration.h file and use it to generate the hex filename
  724. FW_MAJOR=$(grep --max-count=1 "\bFW_MAJOR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  725. FW_MINOR=$(grep --max-count=1 "\bFW_MINOR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  726. FW_REVISION=$(grep --max-count=1 "\bFW_REVISION\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  727. FW="$FW_MAJOR$FW_MINOR$FW_REVISION"
  728. #FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  729. if [ -z "$BUILD" ] ; then
  730. # Find build version in Configuration.h file and use it to generate the hex filename
  731. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  732. else
  733. # Find and replace build version in Configuration.h file
  734. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  735. echo "Original build number: $BUILD_ORG"
  736. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  737. fi
  738. # Check if the motherboard is an EINSY and if so only one hex file will generated
  739. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  740. # Check development status
  741. FW_FLAV=$(grep --max-count=1 "//#define FW_FLAVOR\b" $SCRIPT_PATH/Firmware/Configuration.h|cut -d ' ' -f1)
  742. if [[ "$FW_FLAV" != "//#define" ]] ; then
  743. FW_FLAVOR=$(grep --max-count=1 "\bFW_FLAVOR\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  744. FW_FLAVERSION=$(grep --max-count=1 "\bFW_FLAVERSION\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  745. if [[ "$FW_FLAVOR" != "//#define FW_FLAVOR" ]] ; then
  746. FW="$FW-$FW_FLAVOR"
  747. DEV_CHECK="$FW_FLAVOR"
  748. if [ ! -z "$FW_FLAVERSION" ] ; then
  749. FW="$FW$FW_FLAVERSION"
  750. fi
  751. fi
  752. fi
  753. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  754. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  755. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  756. DEV_STATUS="RC"
  757. elif [[ "$DEV_CHECK" == *"ALPHA"* ]]; then
  758. DEV_STATUS="ALPHA"
  759. elif [[ "$DEV_CHECK" == *"BETA"* ]]; then
  760. DEV_STATUS="BETA"
  761. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  762. DEV_STATUS="DEVEL"
  763. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  764. DEV_STATUS="DEBUG"
  765. else
  766. DEV_STATUS="UNKNOWN"
  767. echo
  768. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  769. PS3="Select YES only if source code is tested and trusted: "
  770. select yn in "Yes" "No"; do
  771. case $yn in
  772. Yes)
  773. DEV_STATUS="GOLD"
  774. DEV_STATUS_SELECTED="GOLD"
  775. break
  776. ;;
  777. No)
  778. DEV_STATUS="UNKNOWN"
  779. DEV_STATUS_SELECTED="UNKNOWN"
  780. break
  781. ;;
  782. *)
  783. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  784. ;;
  785. esac
  786. done
  787. fi
  788. else
  789. DEV_STATUS=$DEV_STATUS_SELECTED
  790. fi
  791. #Prepare hex files folders
  792. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  793. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  794. fi
  795. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  796. if [ "$BOARD" != "prusa_einsy_rambo" ]; then
  797. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD" ]; then
  798. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD || exit 28
  799. fi
  800. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$BOARD"
  801. fi
  802. #Check if exactly the same hexfile already exists
  803. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  804. echo ""
  805. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  806. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  807. if [ $OUTPUT == "1" ] ; then
  808. read -t 10 -p "Press Enter to continue..."
  809. fi
  810. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  811. echo ""
  812. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  813. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  814. if [ $OUTPUT == "1" ] ; then
  815. read -t 10 -p "Press Enter to continue..."
  816. fi
  817. fi
  818. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  819. echo ""
  820. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  821. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  822. if [ $OUTPUT == "1" ] ; then
  823. read -t 10 -p "Press Enter to continue..."
  824. fi
  825. fi
  826. #List some useful data
  827. echo "$(tput setaf 2)$(tput setab 7) "
  828. echo "Printer :" $MK404_PRINTER
  829. echo "Variant :" $VARIANT
  830. echo "Firmware :" $FW
  831. echo "Build # :" $BUILD
  832. echo "Dev Check :" $DEV_CHECK
  833. echo "DEV Status :" $DEV_STATUS
  834. echo "Motherboard:" $MOTHERBOARD
  835. echo "Board flash:" $BOARD_FLASH
  836. echo "Board mem :" $BOARD_MEM
  837. echo "Languages :" $LANGUAGES
  838. echo "Hex-file Folder:" $OUTPUT_FOLDER
  839. echo "$(tput sgr0)"
  840. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  841. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  842. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  843. else
  844. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  845. if [ $OUTPUT == "1" ] ; then
  846. read -t 10 -p "Press Enter to continue..."
  847. fi
  848. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  849. fi
  850. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  851. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  852. # set FW_REPOSITORY
  853. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  854. #Prepare English only or multi-language version to be build
  855. if [ $LANGUAGES == "EN_ONLY" ]; then
  856. echo " "
  857. echo "English only language firmware will be built"
  858. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  859. echo " "
  860. else
  861. echo " "
  862. echo "Multi-language firmware will be built"
  863. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  864. echo " "
  865. fi
  866. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  867. #if [ $TARGET_OS == "windows" ]; then
  868. #RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  869. #fi
  870. #New fresh PF-Firmware-build
  871. if [ "$new_build_flag" == "1" ]; then
  872. rm -r -f $BUILD_PATH/* || exit 54
  873. fi
  874. # Prepare Board mem and flash modifications
  875. ## Check board mem size
  876. CURRENT_BOARD_MEM=$(grep "#define RAMEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  877. if [ $CURRENT_BOARD_MEM != "0x21FF" ] ; then
  878. echo "Board mem has been already modified or not reset"
  879. echo "Current:" $CURRENT_BOARD_MEM
  880. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  881. select yn in "Yes" "No"; do
  882. case $yn in
  883. Yes)
  884. echo "Resetting board mem size"
  885. sed -i -- "s/^#define RAMEND .*$/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  886. break
  887. ;;
  888. *)
  889. echo "Continuing with modified mem size"
  890. break
  891. ;;
  892. esac
  893. done
  894. fi
  895. ## Modify board mem size
  896. if [[ ! -z $BOARD_MEM && "$BOARD_MEM" != "0x21FF" ]] ; then
  897. echo "$(tput setaf 3)Modifying board memory size (hex):$(tput sgr 0)"
  898. echo "Old:" $CURRENT_BOARD_MEM
  899. echo "New:" $BOARD_MEM
  900. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  901. echo ""
  902. sed -i -- "s/^#define RAMEND 0x21FF/#define RAMEND ${BOARD_MEM}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  903. fi
  904. ## Check board flash size
  905. CURRENT_BOARD_FLASH=$(grep "#define FLASHEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  906. CURRENT_BOARD_maximum_size=$(grep "prusa_einsy_rambo.upload.maximum_size" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt |cut -d '=' -f2|tr -d $'\n')
  907. if [[ $CURRENT_BOARD_FLASH != "0x3FFFF" || $CURRENT_BOARD_maximum_size != "253952" ]] ; then
  908. echo "Board flash has been already modified or not reset"
  909. echo "Current flash size:" $CURRENT_BOARD_FLASH
  910. echo "Current max. size:" $CURRENT_BOARD_maximum_size
  911. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  912. select yn in "Yes" "No"; do
  913. case $yn in
  914. Yes)
  915. echo "$(tput setaf 1)Resetting board flash size$(tput sgr 0)"
  916. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  917. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  918. break
  919. ;;
  920. *)
  921. echo "$(tput setaf 3)Continuing with modified flash size$(tput sgr 0)"
  922. break
  923. ;;
  924. esac
  925. done
  926. fi
  927. ## Modify boad flash size
  928. if [[ ! -z $BOARD_FLASH && "$BOARD_FLASH" != "0x3FFFF" ]] ; then
  929. echo "Modifying board flash size (hex):"
  930. echo "Old flash size:" $CURRENT_BOARD_FLASH
  931. echo "New flash size:" $BOARD_FLASH
  932. echo "Old max. size:" $CURRENT_BOARD_maximum_size
  933. echo "New max. size:" $BOARD_maximum_size
  934. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  935. sed -i -- "s/^#define FLASHEND .*/#define FLASHEND ${BOARD_FLASH}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  936. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=${BOARD_maximum_size}/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  937. fi
  938. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  939. # if [ $TARGET_OS == "windows" ]; then
  940. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  941. # fi
  942. #### End of Prepare building
  943. #### Start building
  944. export ARDUINO=$BUILD_ENV_PATH
  945. #echo $BUILD_ENV_PATH
  946. #export BUILDER=$ARDUINO/arduino-builder
  947. echo
  948. #read -t 5 -p "Press Enter..."
  949. echo
  950. echo "Start to build Prusa Firmware ..."
  951. echo "Using variant $VARIANT$(tput setaf 3)"
  952. if [ $OUTPUT == "1" ] ; then
  953. sleep 2
  954. fi
  955. if [ $verbose_IDE == "1" ]; then
  956. $BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 41
  957. fi
  958. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all -verbose=$verbose_IDE $SCRIPT_PATH/Firmware/Firmware.ino || exit 42
  959. echo "$(tput sgr 0)"
  960. if [ $LANGUAGES == "ALL" ]; then
  961. echo "$(tput setaf 2)"
  962. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  963. echo "$(tput sgr 0)"
  964. if [ $OUTPUT == "1" ] ; then
  965. sleep 2
  966. fi
  967. cd $SCRIPT_PATH/lang
  968. echo "$(tput setaf 3)"
  969. ./config.sh || exit 43
  970. echo "$(tput sgr 0)"
  971. # Check if previous languages and firmware build exist and if so clean them up
  972. if [ -f "lang_en.tmp" ]; then
  973. echo ""
  974. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  975. if [ $OUTPUT == "1" ] ; then
  976. read -t 10 -p "Press Enter to continue..."
  977. fi
  978. echo "$(tput setaf 3)"
  979. ./lang-clean.sh
  980. echo "$(tput sgr 0)"
  981. fi
  982. if [ -f "progmem.out" ]; then
  983. echo ""
  984. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  985. if [ $OUTPUT == "1" ] ; then
  986. read -t 10 -p "Press Enter to continue..."
  987. fi
  988. echo "$(tput setaf 3)"
  989. ./fw-clean.sh
  990. echo "$(tput sgr 0)"
  991. fi
  992. # build languages
  993. echo "$(tput setaf 3)"
  994. ./lang-build.sh || exit 44
  995. # build community languages
  996. ./lang-community.sh || exit 45
  997. # Combine compiled firmware with languages
  998. ./fw-build.sh || exit 46
  999. cp not_tran.txt not_tran_$VARIANT.txt
  1000. cp not_used.txt not_used_$VARIANT.txt
  1001. echo "$(tput sgr 0)"
  1002. # Check if the motherboard is an EINSY and if so only one hex file will generated
  1003. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  1004. # If the motherboard is an EINSY just copy one hexfile
  1005. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  1006. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  1007. # Make a copy of "lang.bin" for MK404 MK3 and MK3S
  1008. if [ ! -z "$mk404_flag" ]; then
  1009. cp -f lang.bin $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin
  1010. fi
  1011. # End of "lang.bin" for MK3 and MK3S copy
  1012. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1013. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.elf
  1014. else
  1015. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  1016. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  1017. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  1018. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  1019. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  1020. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  1021. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  1022. cp -f firmware_nl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-nl.hex
  1023. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.elf
  1024. if [ $TARGET_OS == "windows" ]; then
  1025. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1026. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1027. elif [ $TARGET_OS == "linux" ]; then
  1028. # Make a copy for MK404 sim of MK2, MK2.5, MK2.5S firmware
  1029. if [ ! -z "$mk404_flag" ]; then
  1030. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1031. fi
  1032. # End of MK2, MK2.5, MK2.5S firmware copy
  1033. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1034. fi
  1035. fi
  1036. # Cleanup after build
  1037. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  1038. echo "$(tput setaf 3)"
  1039. ./fw-clean.sh || exit 51
  1040. ./lang-clean.sh || exit 52
  1041. echo "$(tput sgr 0)"
  1042. fi
  1043. else
  1044. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  1045. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 47
  1046. echo "$(tput setaf 2)Copying English only elf file to PF-build-hex folder$(tput sgr 0)"
  1047. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.elf || exit 47
  1048. fi
  1049. # Cleanup Firmware
  1050. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  1051. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 53
  1052. fi
  1053. # Delete dupblicates
  1054. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  1055. then
  1056. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  1057. fi
  1058. # MK2 not supported in this branch
  1059. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  1060. then
  1061. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  1062. fi
  1063. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  1064. then
  1065. rm $SCRIPT_PATH/lang/not_tran.txt
  1066. fi
  1067. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  1068. then
  1069. rm $SCRIPT_PATH/lang/not_used.txt
  1070. fi
  1071. #New fresh PF-Firmware-build
  1072. if [ "$new_build_flag" == "1" ]; then
  1073. rm -r -f $BUILD_PATH/* || exit 54
  1074. fi
  1075. # Restore files to previous state
  1076. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  1077. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  1078. if [ ! -z "$BUILD_ORG" ] ; then
  1079. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  1080. fi
  1081. echo $MULTI_LANGUAGE_CHECK
  1082. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  1083. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1084. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1085. if [ $OUTPUT == "1" ] ; then
  1086. sleep 5
  1087. fi
  1088. # Restore build env files to previous state
  1089. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1090. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  1091. sed -i -- "s/^#define RAMEND.*/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1092. done
  1093. # Switch to hex path and list build files
  1094. cd $SCRIPT_PATH
  1095. echo "$(tput setaf 2) "
  1096. echo " "
  1097. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  1098. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  1099. #### End building
  1100. #### MK404 Simulator
  1101. # Check/compile MK404 sim
  1102. if [ ! -z "$mk404_flag" ]; then
  1103. ./MK404-build.sh -c1 || exit 61
  1104. # For Prusa MK2, MK2.5/S
  1105. if [ "$MOTHERBOARD" == "BOARD_RAMBO_MINI_1_3" ]; then
  1106. MK404_PRINTER="${MK404_PRINTER}_mR13"
  1107. else
  1108. if [[ "$mk404_flag" == "2" || "$mk404_flag" == "MMU2" || "$mk404_flag" == "MMU2S" ]]; then # Check if MMU2 is selected only for MK3/S
  1109. MK404_PRINTER="${MK404_PRINTER}MMU2"
  1110. fi
  1111. fi
  1112. # Run MK404 with 'debugcore' and/or 'bootloader-file'
  1113. echo "MK404_DEBUG --$MK404_DEBUG--"
  1114. if [ "$MK404_DEBUG" == "atmega404" ]; then
  1115. MK404_options="--debugcore"
  1116. elif [ "$MK404_DEBUG" == "atmega404_no_bootloader" ]; then
  1117. MK404_options='--debugcore --bootloader-file ""'
  1118. fi
  1119. # Run MK404 with grafics
  1120. if [ ! -z "$graphics_flag" ]; then
  1121. echo "MK404_options --$MK404_options--"
  1122. if [ ! -z "$MK404_options" ]; then
  1123. MK404_options="${MK404_options} --colour-extrusion --extrusion Quad_HR -g "
  1124. else
  1125. MK404_options="--colour-extrusion --extrusion Quad_HR -g "
  1126. fi
  1127. if [[ "$graphics_flag" == "1" || "$graphics_flag" == "lite" ]]; then
  1128. MK404_options="${MK404_options}lite"
  1129. elif [[ "$graphics_flag" == "2" || "$graphics_flag" == "fancy" ]]; then
  1130. MK404_options="${MK404_options}fancy"
  1131. else
  1132. echo "$(tput setaf 1)Unsupported MK404 graphics option $graphics_flag$(tput sgr 0)"
  1133. fi
  1134. fi
  1135. # Output some useful data
  1136. echo "Printer: $MK404_PRINTER"
  1137. echo "Options: $MK404_options"
  1138. # Change to MK404 build folder
  1139. cd ../MK404/master/build
  1140. # Copy language bin file for MK3 and MK3S to xflash
  1141. # if [ -f $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin ]; then
  1142. # echo "Copy 'FW$FW-Build$BUILD-$VARIANT-lang.bin' to 'Prusa_${MK404_PRINTER}_xflash.bin'"
  1143. # dd if=/dev/zero bs=1 count=262145 | tr "\000" "\377" >Prusa_${MK404_PRINTER}_xflash.bin
  1144. # dd if=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin of=Prusa_${MK404_PRINTER}_xflash.bin conv=notrunc
  1145. # fi
  1146. #Decide which hex file to use EN_ONLY or Multi language
  1147. if [ "$LANGUAGES" == "ALL" ]; then
  1148. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1149. else
  1150. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex
  1151. fi
  1152. # Start MK404
  1153. # default with serial output and terminal to manipulate it via terminal
  1154. ./MK404 Prusa_$MK404_PRINTER -s --terminal $MK404_options -f $MK404_firmware_file || exit 62
  1155. fi
  1156. #### End of MK404 Simulator